# -*- encoding : utf-8 -*-
class Kadmos::WebApp
  @@api_route = Proc.new do |endpoint, responder_class, plugin = nil|
     raise "Corpus #{@corpus_name} does not exist or requires additional rights." unless @corpus
     raise "No endpoint #{endpoint}" unless File.exists? api_file=(plugin ? "plugins/kadmos_plugin_#{plugin}/api_#{endpoint}.rb" : "controllers/api_#{endpoint}.rb")
     responder_class.new do |out|
       begin
         instance_eval(File.read(api_file), File.join(File.dirname(__FILE__),api_file))
       rescue Exception => ex
         out.event "Error"
         out.data [ex.inspect]+ex.backtrace
       end
     end.respond
  end
  get "/api/:endpoint" do |endpoint|
     instance_exec endpoint, EventSource, &@@api_route
  end
  post "/api/:endpoint" do |endpoint|
    instance_exec endpoint, EventSource, &@@api_route
  end
  get "/rest-api/:endpoint" do |endpoint|
    instance_exec endpoint, MockEventSource, &@@api_route
  end
  post "/rest-api/:endpoint" do |endpoint|
    instance_exec endpoint, MockEventSource, &@@api_route
  end
  get "/plugin-api/:plugin/:endpoint" do |plugin, endpoint|
     instance_exec endpoint, EventSource, plugin, &@@api_route if File.exist? File.join("plugins","kadmos_plugin_#{plugin}","plugin.rb")
  end
  post "/plugin-api/:plugin/:endpoint" do |plugin, endpoint|
    instance_exec endpoint, EventSource, plugin, &@@api_route if File.exist? File.join("plugins","kadmos_plugin_#{plugin}","plugin.rb")
  end
  get "/plugin-rest-api/:plugin/:endpoint" do |plugin, endpoint|
    instance_exec endpoint, MockEventSource, plugin, &@@api_route if File.exist? File.join("plugins","kadmos_plugin_#{plugin}","plugin.rb")
  end
  post "/plugin-rest-api/:plugin/:endpoint" do |plugin, endpoint|
    instance_exec endpoint, MockEventSource, plugin, &@@api_route if File.exist? File.join("plugins","kadmos_plugin_#{plugin}","plugin.rb")
  end
end
