# -*- encoding : utf-8 -*-
next unless concept_json = params[:concepts]
next unless     concepts = MultiJson.load(concept_json)
              concept_id = Time.now.to_f.to_s.split(".").tap{|a|a[-1]=a.last.to_sym.hash}.join("-").gsub("--","-")
     concept_storage_dir = "db/#{@corpus_name}/conceptstorage"

Dir.mkdir(concept_storage_dir) unless File.exists?(concept_storage_dir)
File.open("#{concept_storage_dir}/#{concept_id}.json","w"){|file| file.write concept_json}

@wordform_list=[]
def build_tree node, remainder
  children = remainder.select{|c|c["parentid"]==node["id"]}
  node["wordforms"] = (node["wordforms"]||[]).map{|w|@wordform_list<<w;{string:w,wordform_id:@wordform_list.size-1}} if node["type"]=="word"
  node["children"]  = children unless children.size==0
  remainder = remainder - children
  children.each{|c| build_tree c, remainder}
end

main_concept = concepts.delete concepts.find{|c|c["type"]=="mainConcept"}
build_tree main_concept, concepts
File.open("#{concept_storage_dir}/#{concept_id}_wordforms.txt","w"){|file| file.write @wordform_list.join("\n")}
File.open("#{concept_storage_dir}/#{concept_id}_packed.json","w"){|file| file.write MultiJson.dump main_concept}

def save_tree entry, parent_node
  entry_node = @corpus.create_concept_node
  @corpus.draw_belongs_to_edge entry_node, parent_node
  entry["wordforms"].each{|w| p(w) ; @corpus.draw_belongs_to_edge(@corpus.get_type_node(string_value:w[:string]), entry_node)} if entry["type"] == "word"
  (entry["children"]||[]).each{|child| save_tree child, entry_node}
end

if main_concept
  root_node = @corpus.create_concept_node(string_value:concept_id)
  root_node.ensure_name main_concept["label"]
  (main_concept["children"]||[]).each{|child| save_tree child, root_node}
end

out.object concept_id

@corpus.commit
