# -*- encoding : utf-8 -*-
Encoding.default_external = 'utf-8'
Encoding.default_internal = 'utf-8'

Bundler.require :importer_mysql

class ::Kadmos::EaquaImporter < ::Kadmos::Importer
  include ::Kadmos::GreekNormalizer
  Settings ||= ::Kadmos::Settings

  def generate_reference v
    v = v.select{|s|s!="" && s!="0"}
    labels = v.count % 2 ==1 ? (l=v.pop) ? l.split(/\/+/).map(&:strip) : nil : nil
    from = v[0...v.count.div(2)]
    to   = v[v.count.div(2)..-1]
    from = from.each_with_index.map{|f,i| "#{labels[i]} #{f}" } if labels
    to   =   to.each_with_index.map{|t,i| "#{labels[i]} #{t}" } if labels
    from == to ? "#{from.join(", ")}" : "#{from.join(", ")} - #{to.join(", ")}"
  end

  def self.import corpus, out=nil, settings={}
    self.new(corpus,{cache_size:15000}).import do

      begin

      def section description
        reset_counter :section_token
        new_section = structural_element :section, :document
        new_section[:string_value] = description
        new_section
      end

      [:btl].each do |db_name| #:TLG, :btl
        db = ::Sequel.connect("jdbc:mysql://#{Settings.importer.mysql.host||"127.0.0.1"}/#{db_name}?user=#{Settings.importer.mysql.user}&password=#{Settings.importer.mysql.password}")
        def db.inspect ; to_s ; end # we do not want to see the database credentials

        work_ids = db[:works].map{|r|r[:work_id]}
        work_ids.each do |work_id|
                  doc_id = db[:works][:work_id=>work_id][:corpora_work_id]
               doc_title = db[:works][:work_id=>work_id][:work]
               author_id = db[:works][:work_id=>work_id][:corpora_author_id]
             author_name = db[:works].join(:authors, :corpora_author_id=>:corpora_author_id).where(:work_id=>work_id).first[:author]
                   units = db[:s_pos].join(:sentences,:s_id=>:s_id).join(:inv_works, :s_id=>:s_id).where(:work_id=>work_id).map{|e| [ e[:sentence], e.keys.select{|c|c.to_s.match(/_[es]$|cit$/)}.map{|c|e[c]} ] }
          doc_identifier = "#{db_name.to_s.downcase}:#{author_id}:#{doc_id}"

          out.data "<Doc:#{doc_identifier}>" if out

          next if @corpus.find_document_nodes(string_value:doc_identifier).first

          document(string_value:doc_identifier).ensure_name(doc_title.strip)

          author(string_value:"#{db_name.to_s.downcase}:#{author_id}").ensure_name(author_name.strip)

          units.each do |content, positioning|
            section generate_reference positioning
            content.split(/ +/).each do |s|
              begin
                token s
              rescue Exception => ex
                p "Error #{ex} while handling word: #{s}"
                sleep 0.1
                retry
              end
            end
          commit
          end

          commit

        end
      end

      rescue Exception => ex
        out.object ex
        out.object ex.backtrace
      end

    end
  end

end