# -*- encoding : utf-8 -*-
Encoding.default_external = 'utf-8'
Encoding.default_internal = 'utf-8'

require 'open-uri'
java_import "java.util.zip.ZipInputStream"
java_import "java.io.ByteArrayInputStream"

class ::Kadmos::ReutersImporter < ::Kadmos::Importer
  include ::Kadmos::GreekNormalizer

  def self.import corpus, out=nil, settings={}
    self.new(corpus).import do

      articles = []
      out.data "Downloading data" if out
      @@reuters_master_zip ||= ""
      @@reuters_master_zip = IO.binread("https://github.com/fergiemcdowall/reuters-21578-json/archive/master.zip") if @@reuters_master_zip == ""

      out.data "Unzipping data" if out
      zip = ZipInputStream.new ByteArrayInputStream.new(@@reuters_master_zip.to_java_bytes)
      while entry = zip.get_next_entry do
        if entry.name.match /^reuters-21578-json-master\/data\/full\/./
          buffer = Java::byte[1024].new
          content = Java::byte[0].new
          while (length = zip.read(buffer, 0, 1024)) > 0 do
            content += buffer[0...length]
          end
          articles += ::MultiJson.load String.from_java_bytes content
        end
        zip.close_entry
      end
      articles.count

      out.data "Importing #{articles.count} articles" if out
      articles.each do |a|
        out.data "." if out
        document(string_value:"#{a["date"]}-#{a["title"]}").ensure_name(a["title"])
        author(string_value:"Reuters").ensure_name("Reuters")
        (a["body"]||"").split(/\s+/).each do |t|
          #next if t.gsub(/\W+/,'')==''
          begin
            token t #t.gsub(/[^\w'.\/]+|\.\b/,"") #'
          rescue Exception => ex
            p [t,ex]
          end
        end
        commit
      end

    end
  end

end