# -*- encoding : utf-8 -*-
Encoding.default_external = 'utf-8'
Encoding.default_internal = 'utf-8'

class ::Kadmos::TxtImporter < ::Kadmos::Importer
  include ::Kadmos::GreekNormalizer

  def self.import corpus, out=nil, settings={}
    self.new(corpus).import do

      files = Dir["importer/txt/input/*.txt"]
      out.data "Importing #{files.count} files" if out
      files.each do |f|
        next unless File.exists? f
        out.data "." if out
        document(string_value:"#{f}").ensure_name(f.gsub(/^importer[\/\\]txt[\/\\]input[\/\\]|\.txt$/,''))
        author(string_value:"charles_dickens").ensure_name("Charles Dickens")
        File.read(f).split(/\s+/).each do |t|
          begin
            token t.gsub(/[äöüÄÖÜßẞ]/, "ä"=>"ae", "ö"=>"oe", "ü"=>"ue", "ß"=>"ss", "Ä"=>"Ae", "Ö"=>"Oe", "Ü"=>"ue", "ẞ"=>"SS")
          rescue Exception => ex
            p [t,ex]
          end
        end
        commit
      end

    end
  end

end