# -*- encoding : utf-8 -*-
Encoding.default_external = 'utf-8'
Encoding.default_internal = 'utf-8'

require 'open-uri'
java_import "java.util.zip.ZipInputStream"
java_import "java.io.ByteArrayInputStream"

class ::Kadmos::VoynichImporter < ::Kadmos::Importer
  include ::Kadmos::GreekNormalizer

  def self.import corpus, out=nil, settings={}
    self.new(corpus).import do

      out.data "Downloading file." if out

      require "open-uri"
      entries = Hash[open("http://www.ic.unicamp.br/~stolfi/voynich/Notes/060/L16+H-eva/text16e7.evt").
        map{|l| l.encode('utf-8', 'binary', :invalid => :replace, :undef => :replace)}.
        reject{|l| l.match /^\s*#|^$/}.
        map{|l|
          m,d = l.split(/(?<=[A-Z]>)\s+/)
          [m.match(/^<f(\d+)([vr])(\d?)\.([^.]+)\.([^.]+);(\D+)(\d?)>$/).to_a[1..-1],d.gsub("\n","")].flatten(1)
        }.
        group_by{|f,p,n,u,l,t,v|[f,p,n,u,l]}.
        map{|(f,p,n,u,l),v| ["Folio #{f}#{{"r"=>", recto","v"=>", verso"}[p]}#{", extended sheet (#{n})" if n!=""}, unit #{u}, line #{l}",Hash[v.map{|e|[e[-3..-2],e.last]}]]}
      ]

      out.data "Importing #{entries.count} lines." if out

      document(string_value:"voynich_text16e7_evt").ensure_name("Voynich Manuscript")

      entries.each do |k,v|
        out.data "." if out
        section k
        v.first.last.gsub(/[!&]/,"").split(".").each{|s| token s}
        commit
      end

    end
  end

end