# -*- encoding : utf-8 -*-

module Kadmos

  class CorpusGraphs
    @@graphs={}

    def self.initialize
      @@system_graph = KadmosGraph.new Pacer.titan "system-graph.properties"
      GraphSchema.setup_graph_database @@system_graph
      Dir.mkdir "db/default" unless Dir.exists? "db/default"
      update
    end

    def self.list
      @@graphs.keys
    end

    def self.[] k
      @@graphs[k]
    end

    def self.update
      current_dirs = Dir["db/*"].to_a-Dir["db/system"].to_a
      current_keys = current_dirs.map{|d| d.gsub(/.*[\\\/]/,"").to_sym}
      (@@graphs.keys-current_keys).each{|k| @@graphs.delete k}
      current_dirs.each do |d|
        next unless File.exists? d
        k = d.gsub(/.*[\\\/]/,"").to_sym
        properties_file = "#{d}/graph.properties"
        if ! File.exists? properties_file
          FileUtils.cp "corpus-graph-default.properties", properties_file
        end
        next if @@graphs[k]
        @@graphs[k] = KadmosGraph.new Pacer.titan properties_file
        GraphSchema.setup_graph_database @@graphs[k]
      end
    end

    @@system_graph = nil
    def self.system_graph
      @@system_graph
    end

    initialize

  end

end
