# -*- encoding : utf-8 -*-

require "multi_json"

module Kadmos

class EventSource
  def initialize &b
    @e=Enumerator.new do |out|
      def out.publish s
        begin
          public_send :yield, s
        rescue org.eclipse.jetty.io.EofException
          begin
            throw(:async)
          rescue ArgumentError
          end
        end
      end
      def out.data d=""
        publish "data: #{d.to_s.gsub("\n","")}\n\n"
      end
      def out.event s=""
        publish "event: #{s.gsub("\n","")}\ndata:\n\n"
      end
      def out.object o
        data ::MultiJson.dump(o).gsub(/\n/,"\n")
      end
      def out.async?
        true
      end
      out.publish "retry: -1\n\n"
      out.event "beginning"
      b.call out
      out.event "finished"
    end
  end
  def each &b
    @e.each &b
  end
  def respond
    r = ::Rack::Response.new [], 200, {"Content-Type"=>"text/event-stream; charset=utf-8", "Access-Control-Allow-Origin"=>"*", "Cache-Control"=>"no-cache, no-store", "Pragma"=>"no-cache", "Connection"=>"keep-alive"}
    r.body = self
    r.finish
  end
  def self.respond &b
    new(&b).respond
  end
  def enumerator
    @e
  end
end

class MockEventSource
  def initialize &b
    @out = Object.new
    def @out.last_data
      @last_data
    end
    def @out.data d=""
      @last_data = d
    end
    def @out.object o
      data ::MultiJson.dump(o).gsub(/\n/,"\n")
    end
    def @out.method_missing m, *args, &b
    end
    b.call @out
  end
  def respond
    ::Rack::Response.new( [@out.last_data||""], 200, {"Content-Type"=>"application/json; charset=utf-8", "Access-Control-Allow-Origin"=>"*", "Cache-Control"=>"no-cache, no-store", "Pragma"=>"no-cache"} ).finish
  end
  def self.respond &b
    new(&b).respond
  end
end

end