# -*- encoding : utf-8 -*-

module Kadmos
  class WebApp < ::Sinatra::Base
    def self.const_missing const ; Kadmos.const_get(const) ; end
    set :threaded, :true
    set :server, 'mizuno'
    set :threaded, true
    set :bind, '0.0.0.0'
    set :port, 80 #TODO: read from Settings
    set :root, File.join(File.dirname(__FILE__),"../..")
    set :public_folder, 'static'
    set :sessions, true
    class KadmosAuth < ::Rack::Auth::Basic # To be replaced with Omniauth
      def call(env)
        env["REQUEST_METHOD"].downcase=='options' ? @app.call(env) : super
      end
    end
    use KadmosAuth, "Geschützer Bereich" do |username, password|
      {Settings.webapp.user=>Settings.webapp.password}.to_a.include? [username,password]
    end
    require 'openid/store/filesystem'
    use OmniAuth::Strategies::OpenID, :store => OpenID::Store::Filesystem.new('db/system/omniauth-openid')
    use OmniAuth::Strategies::Identity, :fields => [:email], :model => UserIdentity
    not_found do
      status 404
      haml :"404"
    end
    before do
      @corpus_name = (params[:corpus]||session[:corpus]||"default").to_s.to_sym
      @corpus = ::Kadmos::CorpusGraphs[@corpus_name] # TODO: check for user rights!
      @system = ::Kadmos::CorpusGraphs.system_graph
      @settings = settings
    end
    options '/*' do
      response.headers["Access-Control-Allow-Origin"]  = "*"
      response.headers["Access-Control-Allow-Methods"] = "POST, GET, OPTIONS"
      response.headers["Access-Control-Allow-Headers"] = "Authorization"
      halt 200
    end
  end
end

(Dir["controllers/*.rb"]-Dir["controllers/api_*.rb"]).each{|c| require_relative "../../#{c}"}